--chatgpt对话
require "import"
import "android.widget.*"
import "android.view.*"
import "com.androlua.*"
import "cjson"

messages = {}
function urlEncode(text)
text = tostring(text)
text = text:gsub("\n", "\r\n")
text = text:gsub("([^%w %-%_%.%~])", function(c)
return string.format("%%%02X", string.byte(c))
end)
text = text:gsub(" ", "+")
return text
end

function cleanText(text)
local success, result = pcall(cjson.decode, text)
if success and result then
return result.answer or "文本不可用"
else
return "文本不可用"
end
end

function addMessage(container, title, message)
local scrollView = messagesContainer.getParent()
local fullMessage = title .. " " .. message
local textView = TextView(service)
container.addView(textView)
textView.setText(fullMessage)
table.insert(messages, fullMessage)
textView.setTextColor(0xFFFFFFFF)
scrollView.postInvalidate()
scrollView.post(function()
local lastChild = container.getChildAt(container.getChildCount() - 1)
if lastChild then
scrollView.smoothScrollTo(0, lastChild.getTop())
end
end)
textView.setOnLongClickListener(View.OnLongClickListener{
onLongClick = function(view)
view.performHapticFeedback(HapticFeedbackConstants.LONG_PRESS)
local text = tostring(textView.getText())
local codes = {}
for full_pattern,_content in string.gmatch(text, "(.-)\n(.-)\n") do
table.insert(codes, pattern_content)
end
if #codes > 0 then
for i, code in ipairs(codes) do
print(code)
end
else
service.copy(text)
end
return true
end
})
end

layout = {
LinearLayout;
layout_width=-1,
orientation = 1;

{
LinearLayout;
layout_width=-1,
layout_height="5%h";
orientation = 0;
{Button,
text="退出",
onClick=function()
dlg.dismiss()
end,
layout_width="10%w",
layout_height="5%h",
};
{TextView,
text="ChatGPT English",
Gravity="center_horizontal",
layout_width="60%w",
layout_height="5%h",
};

{
Button;
text= "另存为";
layout_width="10%w",
layout_height="5%h";
onClick = function()
local save_layout = {
LinearLayout;
orientation = 1;
layout_width=-1,
{
EditText;
hint = "输入文件名";
id = "fileEdit";
layout_width=-1,
layout_height="10%h";
};
{
Button;
text = "保存";
layout_width=-1,
layout_height="10%h";
onClick = function()
local name = fileEdit.getText().toString()
save_dlg.dismiss()
if name ~= "" then
local filename = "/sdcard/解说/SavedChats/" .. name .. ".txt"
os.execute("mkdir -p /sdcard/解说/SavedChats")
local file = io.open(filename, "w")
if #messages > 0 then
for i, message in ipairs(messages) do
file:write(message .. "\n")
end
file:close()
service.postSpeak(200, "文本保存成功")
else
service.postSpeak(200, "无法保存空文件")
end
else
service.postSpeak(200, "请输入文件名")
end
end;
};
}
save_dlg = LuaDialog()
save_dlg.setTitle("保存聊天")
save_dlg.setView(loadlayout(save_layout))
save_dlg.show()
end;
};


{
Button;
text= "打开保存文件";
layout_width="10%w",
layout_height="5%h";
onClick = function()
local save_layout = {
LinearLayout;
orientation = 1;
layout_width=-1,
{
ListView;
id = "saved";
layout_width=-1,
layout_height = -1;
};
}
saved_dlg = LuaDialog()
saved_dlg.setTitle("保存的文件")
saved_dlg.setView(loadlayout(save_layout))
saved_dlg.show()
local chats_folder = "/sdcard/解说/SavedChats"
local dir = io.popen("ls -t " .. chats_folder)
local chats = {}
for chat in dir:lines() do
chat = chat:gsub(".txt", "")
table.insert(chats, chat)
end
dir:close()
saved.adapter = ArrayAdapter(service, android.R.layout.simple_list_item_1, chats)
saved.onItemClick = function(parent, view, position, id)
local chat = saved.getItemAtPosition(position)
local filename = "/sdcard/解说/SavedChats/" .. chat .. ".txt"
local file = io.open(filename, "r")
for line in file:lines() do
print(line)
end
file:close()
end
end;
};
};


{
ScrollView;
layout_width=-1,
layout_height="85%h";
{
LinearLayout;
id = "messagesContainer";
orientation = 1;
layout_width=-1,
layout_height=-1;
};
};


{
LinearLayout;
layout_width=-1,
layout_height="10%h";
orientation = 0;


{
Button;
text= "清空对话";
layout_width="10%w",
layout_height="10%h";
onClick = function()
messagesContainer.removeAllViews()
table.clear(messages)
end;
};


{
EditText;
hint = "消息";
id = "question";
layout_width="70%w",
layout_height="10%h";
};


{
Button;
text= "发送";
id = "SendButton";
layout_width="10%w",
layout_height="10%h";
onClick = function(view)
local questionText = question.getText().toString()
if questionText == "" then
service.postSpeak(200, "请输入内容")
return
end
local encodedQuestion = urlEncode(questionText)
local url = "https://chatgpt.apinepdev.workers.dev/?question=" .. encodedQuestion
addMessage(messagesContainer, "我：", questionText)
service.postSpeak(200, "Chat GPT正在输入")
Http.get(url, function(status, data)
if status == 200 then
local cleanedData = cleanText(data)
addMessage(messagesContainer, "ChatGPT:", cleanedData)
service.postSpeak(200, cleanedData)
question.setText("")
else
local errorMessage = "An error occurred while processing the request."
addMessage(messagesContainer, "Error:", errorMessage)
service.postSpeak(200, errorMessage)
end
end)
end;
};
};


}

dlg = LuaDialog(this)
dlg.setView(loadlayout(layout))
dlg.show()